#pragma once

#include "../../DNACommon/DNACommon.hpp"
#include "IScriptObject.hpp"
#include "Parameters.hpp"

namespace DataSpec::DNAMP1 {
struct MetroidAlpha : IScriptObject {
  AT_DECL_DNA_YAMLV
  String<-1> name;
  Value<atUint32> unknown1;
  Value<atVec3f> location;
  Value<atVec3f> orientation;
  Value<atVec3f> scale;
  PatternedInfo patternedInfo;
  ActorParameters actorParameters;
  DamageVulnerability damageVulnerabilty1;
  DamageVulnerability damageVulnerabilty2;
  Value<float> unknown2;
  Value<float> unknown3;
  Value<float> unknown4;
  Value<float> unknown5;
  Value<float> unknown6;
  Value<float> unknown7;
  AnimationParameters animationParameters1;
  AnimationParameters animationParameters2;
  AnimationParameters animationParameters3;
  AnimationParameters animationParameters4;
  Value<bool> unknown8;

  void addCMDLRigPairs(PAKRouter<PAKBridge>& pakRouter, CharacterAssociations<UniqueID32>& charAssoc) const override {
    actorParameters.addCMDLRigPairs(pakRouter, charAssoc, patternedInfo.animationParameters);
  }

  void nameIDs(PAKRouter<PAKBridge>& pakRouter) const override {
    patternedInfo.nameIDs(pakRouter, name + "_patterned");
    actorParameters.nameIDs(pakRouter, name + "_actp");
    animationParameters1.nameANCS(pakRouter, name + "_animp1");
    animationParameters2.nameANCS(pakRouter, name + "_animp2");
    animationParameters3.nameANCS(pakRouter, name + "_animp3");
    animationParameters4.nameANCS(pakRouter, name + "_animp4");
  }

  void gatherDependencies(std::vector<hecl::ProjectPath>& pathsOut,
                          std::vector<hecl::ProjectPath>& lazyOut) const override {
    patternedInfo.depIDs(pathsOut);
    actorParameters.depIDs(pathsOut, lazyOut);
    animationParameters1.depANCS(pathsOut);
    animationParameters2.depANCS(pathsOut);
    animationParameters3.depANCS(pathsOut);
    animationParameters4.depANCS(pathsOut);
  }

  void gatherScans(std::vector<Scan>& scansOut) const override { actorParameters.scanIDs(scansOut); }
};
} // namespace DataSpec::DNAMP1
